<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Key Events</title>
    <style>
        body {
            font-size: 14px;
            font-family: monospace;
        }

        #pane {
            width: 100%;
            border: thin solid #333;
            font-size: 2rem;
            padding: auto .5rem;
        }

        #log {
            margin-top: 1rem;
            border: thin solid #777;
            background-color: #fafafa;
            font-size: 2rem;
            padding: 0.3rem;
        }
    </style>
</head>
<body>
    <h1>Key Events</h1>
    <input id="pane" type="text" placeholder="type here..."/>
    <pre id="log"></pre>

    <script>
        function modifiers(ev) {
            let result = [];
            if (ev.altKey) result.push('ALT');
            if (ev.ctrlKey) result.push('CTRL');
            if (ev.metaKey) result.push('META');
            if (ev.shiftKey) result.push('SHIFT');
            return result.length > 0 ? result.join('-') + '-' : '';
        }

        document.querySelector('#pane')
            .addEventListener('keypress', (ev) => {
                document.querySelector('#log')
                    .innerText += `'${ev.key}' (${modifiers(ev)}${ev.code})\n`;
            });
    </script>
</body>
</html>